Index: /trunk/configure.ac
===================================================================
--- /trunk/configure.ac	(revision 7953)
+++ /trunk/configure.ac	(revision 7954)
@@ -601,5 +601,5 @@
 # FIXME: Replace `main' with a function in `-lm':
  AC_CHECK_LIB([m], [main])
-
+ AX_CHECK_REQUIRED_HEADER_LIB([zlib.h], [z], [zlibVersion],,, [http://www.zlib.net])
 
 # Checks for header files.
Index: /trunk/src/defs/class_id.h
===================================================================
--- /trunk/src/defs/class_id.h	(revision 7953)
+++ /trunk/src/defs/class_id.h	(revision 7954)
@@ -366,4 +366,6 @@
   CL_HANDSHAKE                  =    0x00000d06,
   CL_NETWORK_GAME_MANAGER       =    0x00000d07,
+  CL_MESSAGE_MANAGER            =    0x00000d08,
+  CL_SIMPLE_SYNC                =    0x00000d09,
 
 
Index: /trunk/src/lib/BuildLibs.am
===================================================================
--- /trunk/src/lib/BuildLibs.am	(revision 7953)
+++ /trunk/src/lib/BuildLibs.am	(revision 7954)
@@ -11,5 +11,4 @@
                 $(LIB_PREFIX)/sound/libORXsound.a \
                 $(LIB_PREFIX)/event/libORXevent.a \
-                $(LIB_PREFIX)/physics/libORXphysics.a \
                 $(LIB_PREFIX)/particles/libORXparticles.a \
                 $(LIB_PREFIX)/collision_detection/libORXcd.a \
@@ -20,4 +19,6 @@
                 $(LIB_PREFIX)/parser/cmdline_parser/libCmdLineParser.a \
                 $(LIB_PREFIX)/parser/ini_parser/libIniParser.a \
+                $(LIB_PREFIX)/physics/libORXphysics.a \
+                $(LIB_PREFIX)/shell/libORXshell.a \
                 $(LIB_PREFIX)/math/libORXmath.a \
                 $(LIB_PREFIX)/libORXlibs.a
Index: /trunk/src/lib/coord/p_node.cc
===================================================================
--- /trunk/src/lib/coord/p_node.cc	(revision 7953)
+++ /trunk/src/lib/coord/p_node.cc	(revision 7954)
@@ -53,4 +53,7 @@
   if (parent != NULL)
     parent->addChild(this);
+
+  this->relCoordinate_handle = this->registerVarId( new SynchronizeableVector( &relCoordinate, &relCoordinate_write, "coordinate" ) );
+  this->relDirection_handle = this->registerVarId( new SynchronizeableQuaternion( &relDirection, &relDirection_write, "direction" ) );
 }
 
@@ -1077,256 +1080,19 @@
 
 /**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int PNode::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( BaseObject::writeState, NWT_PN_BO_WRITESTATE );
-
-  //   char * parentName = NULL;
-  //   SYNCHELP_READ_STRINGM( parentName );
-  //
-  //   if ( strcmp(parentName, "")==0 )
-  //   {
-  //     setParent( (char*)NULL );
-  //   }
-  //   else
-  //   {
-  //     setParent( parentName );
-  //   }
-  //
-  //  delete[] parentName;
-
-  int parentMode;
-  SYNCHELP_READ_INT( parentMode, NWT_PN_PARENTMODE );
-  this->setParentMode((PARENT_MODE)parentMode);
-
-  float f1, f2, f3, f4;
-
-  SYNCHELP_READ_FLOAT( f1, NWT_PN_COORX );
-  SYNCHELP_READ_FLOAT( f2, NWT_PN_COORY );
-  SYNCHELP_READ_FLOAT( f3, NWT_PN_COORZ );
-  this->setRelCoor( f1, f2, f3 );
-
-
-  SYNCHELP_READ_FLOAT( f1, NWT_PN_ROTV );
-  SYNCHELP_READ_FLOAT( f2, NWT_PN_ROTX );
-  SYNCHELP_READ_FLOAT( f3, NWT_PN_ROTY );
-  SYNCHELP_READ_FLOAT( f4, NWT_PN_ROTZ );
-  this->setRelDir( Quaternion( Vector(f2, f3, f4), f1 ) );
-
-  //   int n;
-  //   char * childName;
-  //
-  //   PRINTF(0)("JKLO %d %d %d %d\n", data[__synchelp_read_i], data[__synchelp_read_i+1], data[__synchelp_read_i+2], data[__synchelp_read_i+3]);
-  //   SYNCHELP_READ_INT( n );
-  //   PRINTF(0)("read %s:n=%d\n", this->getName(), n);
-  //
-  //   for (int i = 0; i<n; i++)
-  //   {
-  //     SYNCHELP_READ_STRINGM( childName );
-  //     PRINTF(0)("RCVD CHILD = %s\n", childName);
-  //     addChild( childName );
-  //     delete childName;
-  //     childName = NULL;
-  //   }
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int PNode::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  SYNCHELP_WRITE_FKT( BaseObject::readState, NWT_PN_BO_WRITESTATE );
-
-  //   if ( this->parent )
-  //   {
-  //     SYNCHELP_WRITE_STRING( parent->getName() );
-  //   }
-  //   else
-  //   {
-  //     SYNCHELP_WRITE_STRING( "" );
-  //   }
-
-  SYNCHELP_WRITE_INT( this->parentMode, NWT_PN_PARENTMODE );
-
-  SYNCHELP_WRITE_FLOAT( this->relCoordinate.x, NWT_PN_COORX );
-  SYNCHELP_WRITE_FLOAT( this->relCoordinate.y, NWT_PN_COORY );
-  SYNCHELP_WRITE_FLOAT( this->relCoordinate.z, NWT_PN_COORZ );
-
-  SYNCHELP_WRITE_FLOAT( this->relDirection.w, NWT_PN_ROTV );
-  SYNCHELP_WRITE_FLOAT( this->relDirection.v.x, NWT_PN_ROTX );
-  SYNCHELP_WRITE_FLOAT( this->relDirection.v.y, NWT_PN_ROTY );
-  SYNCHELP_WRITE_FLOAT( this->relDirection.v.z, NWT_PN_ROTZ );
-
-  //   int n = children.size();
-  //   //check if camera is in children
-  //   for (std::std::list<PNode*>::const_iterator it = children.begin(); it!=children.end(); it++)
-  //   {
-  //     if ( (*it)->isA(CL_CAMERA) )
-  //       n--;
-  //   }
-  //   PRINTF(0)("write %s:n=%d\n", this->getName(), n);
-  //   SYNCHELP_WRITE_INT( n );
-  //   PRINTF(0)("ASDF %d %d %d %d\n", data[__synchelp_write_i-4], data[__synchelp_write_i-3], data[__synchelp_write_i-2], data[__synchelp_write_i-1]);
-  //
-  //
-  //   for (std::list<PNode*>::const_iterator it = children.begin(); it!=children.end(); it++)
-  //   {
-  //     //dont add camera because there is only one camera attached to local player
-  //     if ( !(*it)->isA(CL_CAMERA) )
-  //     {
-  //       PRINTF(0)("SENDING CHILD: %s\n", (*it)->getName());
-  //       SYNCHELP_WRITE_STRING( (*it)->getName() );
-  //     }
-  //   }
-
-  return SYNCHELP_WRITE_N;
-}
-
-#define __FLAG_COOR 1
-#define __FLAG_ROT  2
-
-#define __OFFSET_POS 1
-#define __OFFSET_ROT 0.05
-
-/**
- * Writes data from network containing information about the state which has changed
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int PNode::writeSync( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  if ( this->getHostID()==this->getOwner() )
-  {
-    return SYNCHELP_READ_N;
-  }
-
-  byte flags = 0;
-  SYNCHELP_READ_BYTE( flags, NWT_PN_FLAGS );
-  //PRINTF(0)("%s::FLAGS = %d\n", this->getName(), flags);
-
-  float f1, f2, f3, f4;
-
-  if ( flags & __FLAG_COOR )
-  {
-    SYNCHELP_READ_FLOAT( f1, NWT_PN_SCOORX );
-    SYNCHELP_READ_FLOAT( f2, NWT_PN_SCOORY );
-    SYNCHELP_READ_FLOAT( f3, NWT_PN_SCOORZ );
-    PRINTF(0)("RCVD COOR: %f %f %f\n", f1, f2, f3);
-    this->setRelCoor( f1, f2, f3 );
-  }
-
-  if ( flags & __FLAG_ROT )
-  {
-    SYNCHELP_READ_FLOAT( f1, NWT_PN_SROTV );
-    SYNCHELP_READ_FLOAT( f2, NWT_PN_SROTX );
-    SYNCHELP_READ_FLOAT( f3, NWT_PN_SROTY );
-    SYNCHELP_READ_FLOAT( f4, NWT_PN_SROTZ );
-    PRINTF(0)("RCVD QUAT: %f %f %f %f\n", f1, f2, f3, f4);
-    //this->setRelDir( Quaternion( Vector(f2, f3, f4), f1 ) );
-    Quaternion q;
-    q.w = f1;
-    q.v.x = f2;
-    q.v.y = f3;
-    q.v.z = f4;
-    this->setAbsDir( q );
-  }
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int PNode::readSync( byte * data, int maxLength )
-{
-  //WARNING: if you change this file make sure you also change needsReadSync
-  SYNCHELP_WRITE_BEGIN();
-
-  if ( this->getHostID()!=0 && this->getHostID()!=this->getOwner() )
-  {
-    return SYNCHELP_WRITE_N;
-  }
-
-  byte flags = 0;
-  if ( fabs( coorx - relCoordinate.x ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coory - relCoordinate.y ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coorz - relCoordinate.z ) > __OFFSET_POS*0.05*this->velocity.len() )
-    flags |= __FLAG_COOR;
-
-  if ( fabs( rotw - absDirection.w ) > __OFFSET_ROT ||
-       fabs( rotx - absDirection.v.x ) > __OFFSET_ROT ||
-       fabs( roty - absDirection.v.y ) > __OFFSET_ROT ||
-       fabs( rotz - absDirection.v.z ) > __OFFSET_ROT )
-    flags |= __FLAG_ROT;
-
-
-  SYNCHELP_WRITE_BYTE( flags, NWT_PN_FLAGS );
-  PRINTF(0)("FLAGS = %d\n", flags);
-
-  if ( flags & __FLAG_COOR )
-  {
-
-    PRINTF(0)("SEND COOR: %f %f %f\n", this->relCoordinate.x, this->relCoordinate.y, this->relCoordinate.z);
-
-    SYNCHELP_WRITE_FLOAT( this->relCoordinate.x, NWT_PN_SCOORX );
-    SYNCHELP_WRITE_FLOAT( this->relCoordinate.y, NWT_PN_SCOORY );
-    SYNCHELP_WRITE_FLOAT( this->relCoordinate.z, NWT_PN_SCOORZ );
-
-    coorx = relCoordinate.x;
-    coory = relCoordinate.y;
-    coorz = relCoordinate.z;
-  }
-
-  if ( flags & __FLAG_ROT )
-  {
-
-    PRINTF(0)("SEND QUAT: %f %f %f %f\n", this->absDirection.w, this->absDirection.v.x, this->absDirection.v.y, this->absDirection.v.z);
-
-    SYNCHELP_WRITE_FLOAT( this->absDirection.w, NWT_PN_SROTV );
-    SYNCHELP_WRITE_FLOAT( this->absDirection.v.x, NWT_PN_SROTX );
-    SYNCHELP_WRITE_FLOAT( this->absDirection.v.y, NWT_PN_SROTY );
-    SYNCHELP_WRITE_FLOAT( this->absDirection.v.z, NWT_PN_SROTZ );
-
-    rotw = absDirection.w;
-    rotx = absDirection.v.x;
-    roty = absDirection.v.y;
-    rotz = absDirection.v.z;
-  }
-
-  return SYNCHELP_WRITE_N;
-}
-
-bool PNode::needsReadSync( )
-{
-  if ( fabs( coorx - relCoordinate.x ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coory - relCoordinate.y ) > __OFFSET_POS*0.05*this->velocity.len() ||
-       fabs( coorz - relCoordinate.z ) > __OFFSET_POS*0.05*this->velocity.len() )
-    return true;
-
-  if ( fabs( rotw - absDirection.w ) > __OFFSET_ROT ||
-       fabs( rotx - absDirection.v.x ) > __OFFSET_ROT ||
-       fabs( roty - absDirection.v.y ) > __OFFSET_ROT ||
-       fabs( rotz - absDirection.v.z ) > __OFFSET_ROT )
-    return true;
-
-  return false;
-}
+ * handles changes in synchronizable variables
+ * @param id id's which changed
+ */
+void PNode::varChangeHandler( std::list< int > & id )
+{
+  if ( std::find( id.begin(), id.end(), relCoordinate_handle ) != id.end() )
+  {
+    setRelCoor( relCoordinate_write );
+  }
+
+  if ( std::find( id.begin(), id.end(), relDirection_handle ) != id.end() )
+  {
+    setRelDir( relDirection_write );
+  }
+}
+
+
Index: /trunk/src/lib/coord/p_node.h
===================================================================
--- /trunk/src/lib/coord/p_node.h	(revision 7953)
+++ /trunk/src/lib/coord/p_node.h	(revision 7954)
@@ -186,10 +186,4 @@
   float distance(const PNode* node) const { return (this->getAbsCoor() - node->getAbsCoor()).len(); };
 
-  int       writeState(const byte* data, int length, int sender);
-  int       readState(byte* data, int maxLength );
-  int       writeSync(const byte* data, int length, int sender);
-  int       readSync(byte* data, int maxLength );
-  bool      needsReadSync();
-
  private:
   /** tells the child that the parent's Coordinate has changed */
@@ -243,4 +237,13 @@
     float roty;
     float rotz;
+    
+  private:
+    int relCoordinate_handle;
+    int relDirection_handle;
+    Vector relCoordinate_write;
+    Quaternion relDirection_write;
+    
+  public:
+    virtual void varChangeHandler( std::list<int> & id );
 };
 
Index: /trunk/src/lib/graphics/importer/height_map.cc
===================================================================
--- /trunk/src/lib/graphics/importer/height_map.cc	(revision 7953)
+++ /trunk/src/lib/graphics/importer/height_map.cc	(revision 7954)
@@ -603,7 +603,9 @@
   PRINTF(0)("c: %f \n" ,c);
 
+
   height -= ( (a/c)*(x) + (b/c)*(y));
 
-  PRINTF(0)("height: %f \n" ,height );
+  // PRINTF(0)("height: %f \n" ,height );
   return (height + offsetZ);
-}
+
+}
Index: /trunk/src/lib/lang/base_object.cc
===================================================================
--- /trunk/src/lib/lang/base_object.cc	(revision 7953)
+++ /trunk/src/lib/lang/base_object.cc	(revision 7954)
@@ -82,4 +82,5 @@
   assert (!(this->classID & classID & !CL_MASK_SUBSUPER_CLASS_IDA ));
 
+  this->leafClassID = classID;
   this->classID |= (long)classID;
   this->className = className;
@@ -105,8 +106,7 @@
  * Factory::fabricate(Object->getLeafClassID());
  */
-ClassID BaseObject::getLeafClassID() const
+const ClassID& BaseObject::getLeafClassID() const
 {
-  assert (this->classList != NULL);
-  return this->classList->getLeafClassID();
+  return this->leafClassID;
 }
 
@@ -176,33 +176,2 @@
 
 }
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int BaseObject::writeState( const byte * data, int length, int sender )
-{
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_STRING( this->objectName, NWT_BO_NAME );
-
-  return SYNCHELP_READ_N;
-}
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int BaseObject::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  //PRINTF(0)("objectname = %s\n", this->objectName);
-  SYNCHELP_WRITE_STRING( this->objectName, NWT_BO_NAME );
-
-  return SYNCHELP_WRITE_N;
-}
Index: /trunk/src/lib/lang/base_object.h
===================================================================
--- /trunk/src/lib/lang/base_object.h	(revision 7953)
+++ /trunk/src/lib/lang/base_object.h	(revision 7954)
@@ -42,5 +42,5 @@
   /** @returns the classID of the corresponding Object */
   inline int getClassID() const { return this->classID; };
-  ClassID    getLeafClassID() const;
+  const ClassID& getLeafClassID() const;
 
   bool isA (ClassID classID) const;
@@ -52,14 +52,12 @@
   bool operator==(ClassID classID) { return this->isA(classID); };
 
-  int       writeState(const byte* data, int length, int sender);
-  int       readState(byte* data, int maxLength );
-
  protected:
    void setClassID(ClassID classID, const std::string& className);
+   std::string        objectName;        //!< The name of this object
 
  private:
     std::string        className;        //!< the name of the class
     long               classID;          //!< this is the id from the class_id.h enumeration
-    std::string        objectName;       //!< The name of this object
+    ClassID            leafClassID;      //!< The Leaf Class ID
 
     ClassList*         classList;        //!< Pointer to the ClassList this Object is inside of
Index: /trunk/src/lib/network/Makefile.am
===================================================================
--- /trunk/src/lib/network/Makefile.am	(revision 7953)
+++ /trunk/src/lib/network/Makefile.am	(revision 7954)
@@ -13,7 +13,23 @@
                       network_protocol.cc \
 		      server_socket.cc \
+		      tcp_server_socket.cc \
+		      tcp_socket.cc \
+		      udp_server_socket.cc \
+		      udp_socket.cc \
 		      handshake.cc \
 		      network_game_manager.cc \
-		      converter.cc
+		      converter.cc \
+		      message_manager.cc \
+		      network_log.cc \
+		      zip.cc \
+		      \
+		      synchronizeable_var/synchronizeable_var.cc \
+		      synchronizeable_var/synchronizeable_vector.cc \
+		      synchronizeable_var/synchronizeable_int.cc \
+		      synchronizeable_var/synchronizeable_quaternion.cc \
+		      synchronizeable_var/synchronizeable_string.cc \
+		      synchronizeable_var/synchronizeable_float.cc \
+		      synchronizeable_var/synchronizeable_bool.cc \
+		      synchronizeable_var/synchronizeable_uint.cc 
 
 
@@ -29,8 +45,24 @@
                  network_protocol.h \
 		 server_socket.h \
+		 tcp_server_socket.h \
+		 tcp_socket.h \
+		 udp_server_socket.h \
+		 udp_socket.h \
 		 handshake.h \
 		 network_game_manager.h \
 		 converter.h \
-		 netdefs.h
+		 netdefs.h \
+		 message_manager.h \
+		 network_log.h \
+		 zip.h \
+		 \
+		 synchronizeable_var/synchronizeable_var.h \
+		 synchronizeable_var/synchronizeable_vector.h \
+		 synchronizeable_var/synchronizeable_int.h \
+		 synchronizeable_var/synchronizeable_quaternion.h \
+		 synchronizeable_var/synchronizeable_string.h \
+		 synchronizeable_var/synchronizeable_float.h \
+		 synchronizeable_var/synchronizeable_bool.h \
+		 synchronizeable_var/synchronizeable_uint.h
 
 
Index: /trunk/src/lib/network/connection_monitor.cc
===================================================================
--- /trunk/src/lib/network/connection_monitor.cc	(revision 7953)
+++ /trunk/src/lib/network/connection_monitor.cc	(revision 7954)
@@ -10,9 +10,11 @@
 
 ### File Specific:
-   main-programmer: Silvan Nellen
+   main-programmer: Christoph Renner
    co-programmer: ...
 */
 
 #include "connection_monitor.h"
+#include "network_log.h"
+
 #include <debug.h>
 #include <SDL/SDL.h>
@@ -22,126 +24,218 @@
 using namespace std;
 
-ConnectionMonitor::ConnectionMonitor()
-{
-
+/**
+ * constructor
+ * @param userId user's id
+ */
+ConnectionMonitor::ConnectionMonitor( int userId )
+{
   /* set the class id for the base object and add ist to class list*/
   this->setClassID(CL_CONNECTION_MONITOR, "ConnectionMonitor");
-
-  /*initialize variables*/
-
-  /*Data of the lifetime of the ConnectionMonitor Object*/
-  packetToAverage = 100;
-  protocollType = "default(TCP)";
-
-  startTime= SDL_GetTicks();
-  totalReceivedPackets=0;
-  averageDatarate=0;
-  totalLostPackets=0;
-  totalPacketloss=0;
-
-  /*Data of the current packet*/
-  currentPacketID=0;
-  currentPacketTick=0;
-  lastPacketID=0;
-  lastPacketTick=0;
-  currentDelay=0;
-
-  /*Data of the last n packets (n is specified by paxketsToAverage)*/
-  sizeOfLastFewPackets=0;
-  currentDatarate=0;
-  lastFewDelays = new unsigned int [packetToAverage];
-  lastFewPackets = new byte* [packetToAverage];
-  packetCounter=0;
-
-
-}
-
-
-ConnectionMonitor::~ConnectionMonitor()
-{
-
-
-}
-
-
-
-void ConnectionMonitor::processPacket(byte* currentPacket, unsigned int packetLength)
-{
-  /*Process the current Packet*/
-  currentPacketTick = SDL_GetTicks();
-  currentDelay = currentPacketTick - lastPacketTick;
-
-  /*Do whats needed for Averaging*/
-
-  if(packetCounter == packetToAverage)
-    {
-      computeCurrentDatarate();
-      displayStatistic();
-      packetCounter = 0;
-      sizeOfLastFewPackets = 0;
-    }
-
-  lastFewDelays[packetCounter] = currentDelay;
-  lastFewPackets[packetCounter] = currentPacket;
-  sizeOfLastFewPackets += packetLength;
-
-  /*Update the lifetime Variables*/
-  totalReceivedPackets ++;
-  float timeDiff = this->currentPacketTick - this->startTime;
-  if( timeDiff != 0.0f )
-    averageDatarate = totalReceivedPackets/timeDiff;
-
-  /*Preparefor the next Packet*/
-  lastPacketTick = currentPacketTick;
-  packetCounter++;
-}
-
-
-/* Compute the value of current Datarate*/
-void ConnectionMonitor::computeCurrentDatarate()
-{
-  int timeForLastFewPackets=0;
-  for(int i=0;i < packetToAverage;i++)
-    timeForLastFewPackets += lastFewDelays[i];
-
-  if( timeForLastFewPackets != 0)
-    currentDatarate = sizeOfLastFewPackets/timeForLastFewPackets;
-}
-
-void doUDPRelatedStuff()
-{
-  /*  Do protocol related stuff
-
-  Only for Udp:
-  "currentPacketID = getID from package";
-
-  if(currentPacketID - lastPacketID > 1)
+  
+  this->userId = userId;
+  this->ping = 0;
+  this->incomingUnzippedBandWidth = 0;
+  this->outgoingUnzippedBandWidth = 0;
+  this->incomingZippedBandWidth = 0;
+  this->outgoingZippedBandWidth = 0;
+  this->nIncomingPackets = 0;
+  this->nOutgoingPackets = 0;
+  this->nZIncomingPackets = 0;
+  this->nZOutgoingPackets = 0;
+  
+  this->lastPacketTick = 0;
+  this->lastPrintTick = 0;
+}
+
+/**
+ * deconstructor
+ */
+ConnectionMonitor::~ConnectionMonitor( )
+{
+}
+
+/**
+ * process unzipped outgoing packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ */
+void ConnectionMonitor::processUnzippedOutgoingPacket( byte * data, int length, int stateId )
+{
+  int tick = SDL_GetTicks();
+  
+  nOutgoingPackets++;
+  
+  // for ping calculation
+  sentStateTicks[stateId] = tick;
+  
+  // calculate bandwidth
+  outgoingUnzippedPacketHistory[tick] = length;
+  outgoingUnzippedBandWidth = calculateBandWidth( outgoingUnzippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UNZIPPED UPSTREAM: user: %d bandwidth %f\n", userId, outgoingUnzippedBandWidth );
+  
+  // count zero bytes
+  int nZeroBytes = 0;
+  
+  for ( int i = 0; i < length; i++ )
+    if ( data[i] == '\0' )
+      nZeroBytes++;
+  
+  //NETPRINTF(n)( "ZEROBYTES: %d (%f%%)\n", nZeroBytes, ((float)100)*nZeroBytes/length );
+}
+
+/**
+ * process unzipped incoming packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ * @param ackedState state which was acked by this packet
+ */
+void ConnectionMonitor::processUnzippedIncomingPacket( byte * data, int length, int stateId, int ackedState )
+{
+  int tick = SDL_GetTicks();
+  
+  nIncomingPackets++;
+  
+  lastPacketTick = tick;
+  
+  // calculate ping
+  if ( sentStateTicks.find( ackedState ) != sentStateTicks.end() )
   {
-  totalLostPackets += currentPacketID - lastPacketID;
-}
-
-  totalPacketloss = (totalLostPackets/totalReceivedPackets)*100 ;
-  */
-}
-
-
-
-/* Display connectoin statistic*/
-void ConnectionMonitor::displayStatistic()
-{
-//   PRINT(0)("============================================\n");
-//   PRINT(0)("Connection Monitor Network Statistics:\n");
-//   PRINT(0)("Total received packets:",totalReceivedPackets);
-//   PRINT(0)("Average datarate :\n",averageDatarate);
-//   PRINT(0)("Total lost packets:",totalLostPackets);
-//   PRINT(0)("Packetloss [%] :\n",totalPacketloss);
-//
-//   PRINT(0)("Current datarate :\n",currentDatarate);
-//   PRINT(0)("Delays of the last few packets :\n");
-//   for(int i=1 ;i <= packetToAverage-1;i++)
-//     PRINT(0)("%i ",lastFewDelays[i]);
-//
-//   PRINT(0)("============================================\n");
-
-}
-
+    ackDelay.push_back( tick - sentStateTicks[ackedState] );
+  }
+  
+  while ( sentStateTicks.begin() != sentStateTicks.end() && sentStateTicks.begin()->first <= ackedState )
+    sentStateTicks.erase( sentStateTicks.begin() );
+      
+  while ( ackDelay.size() > N_PACKETS_FOR_PING )
+    ackDelay.erase( ackDelay.begin() );
+      
+  ping = 0;
+      
+  for ( std::list<int>::iterator it = ackDelay.begin(); it != ackDelay.end(); it++ )
+    ping += *it;
+      
+  if ( ackDelay.size() == 0 )
+    ping = -1;
+  else
+    ping /= ackDelay.size();
+      
+  //NETPRINTF(n)("PING: user: %d ping: %d\n", userId, ping );
+  
+  // calculate bandwidth
+  incomingUnzippedPacketHistory[tick] = length;
+  incomingUnzippedBandWidth = calculateBandWidth( incomingUnzippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UNZIPPED DOWNSTREAM: user: %d bandwidth %f\n", userId, incomingUnzippedBandWidth );
+  
+}
+
+/**
+ * calculate bandwidth out of packethistory
+ * @param packetHistory packet history
+ * @param tick current tick from SDL_GetTicks
+ * @return bandwidth in bytes/sec
+ */
+float ConnectionMonitor::calculateBandWidth( std::map< int, int > packetHistory, int tick )
+{
+  // delete old packets
+  while ( packetHistory.begin()->first < tick - MSECS_TO_CALC_BWIDTH )
+    packetHistory.erase( packetHistory.begin() );
+  
+  float res = 0.0f;
+  
+  for ( std::map<int,int>::iterator it = packetHistory.begin(); it != packetHistory.end(); it++ )
+  {
+    res += it->second;
+  }
+  
+  if ( packetHistory.size() <= 1 || tick - packetHistory.begin()->first == 0 )
+    res = 0.0f;
+  else
+    res /= (float)((tick - packetHistory.begin()->first)*( 1 + 1/((float)(packetHistory.size()-1)) ));
+  
+  res *= 1000.0f;
+  
+  return res;
+}
+
+
+/**
+ * process zipped outgoing packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ */
+void ConnectionMonitor::processZippedOutgoingPacket( byte * data, int length, int stateId )
+{
+  int tick = SDL_GetTicks();
+  
+  nZOutgoingPackets++;
+  
+  // calculate bandwidth
+  outgoingZippedPacketHistory[tick] = length;
+  outgoingZippedBandWidth = calculateBandWidth( outgoingZippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("UPSTREAM: user: %d bandwidth %f nOutgoingPackets %d\n", userId, outgoingZippedBandWidth, nOutgoingPackets );
+
+  if ( lastPrintTick < tick-1000 )
+  {
+    printStatis();
+    lastPrintTick = tick;
+  }
+}
+
+
+/**
+ * process zipped incoming packet
+ * @param data pointer to packet data
+ * @param length length of packet
+ * @param stateId packet's state id
+ * @param ackedState state which was acked by this packet
+ */
+void ConnectionMonitor::processZippedIncomingPacket( byte * data, int length, int stateId, int ackedState )
+{
+  int tick = SDL_GetTicks();
+  
+  nZIncomingPackets++;
+  
+  // calculate bandwidth
+  incomingZippedPacketHistory[tick] = length;
+  incomingZippedBandWidth = calculateBandWidth( incomingZippedPacketHistory, tick );
+  
+  //NETPRINTF(n)("DOWNSTREAM: user: %d bandwidth %f nIncomingPackets %d\n", userId, incomingZippedBandWidth, nIncomingPackets );
+  
+}
+
+
+/**
+ * check if client sent no packets for SECS_TO_TIMEOUT
+ * @return true if last packet recieved \< NOW() - SECS_TO_TIMEOUT
+ */
+bool ConnectionMonitor::hasTimedOut( )
+{
+  if ( lastPacketTick + SECS_TO_TIMEOUT*1000 < SDL_GetTicks() && nIncomingPackets > 0 )
+    return true;
+  
+  if ( nIncomingPackets == 0 && nOutgoingPackets >= NETWORK_FREQUENCY*SECS_TO_TIMEOUT )
+    return true;
+  
+  return false;
+}
+
+
+
+/**
+ * prints bandwith usage, ping and other important things to telnet-console
+ */
+void ConnectionMonitor::printStatis( )
+{
+  NETPRINT(n)("=========NETWORKSTATS FOR USER %d=========\n", userId);
+  NETPRINT(n)("PING = %d\n", ping);
+  NETPRINT(n)("BANDWIDTH: UP: %f (%f) DOWN %f (%f)\n", outgoingZippedBandWidth, outgoingUnzippedBandWidth, incomingZippedBandWidth, incomingUnzippedBandWidth);
+  NETPRINT(n)("==========================================");
+}
+
+
Index: /trunk/src/lib/network/connection_monitor.h
===================================================================
--- /trunk/src/lib/network/connection_monitor.h	(revision 7953)
+++ /trunk/src/lib/network/connection_monitor.h	(revision 7954)
@@ -10,44 +10,59 @@
 #include "netdefs.h"
 
+#include <map>
+
+#define N_PACKETS_FOR_PING 20
+#define MSECS_TO_CALC_BWIDTH 1000
+#define SECS_TO_TIMEOUT 10
+
 class ConnectionMonitor : virtual public BaseObject
-  {
+{
   public:
-    ConnectionMonitor();
+    ConnectionMonitor( int userId );
     virtual ~ConnectionMonitor();
 
-    void                processPacket(byte* packet, unsigned int packetLength);
+    void processUnzippedOutgoingPacket( byte * data, int length, int stateId );
+    void processUnzippedIncomingPacket( byte * data, int length, int stateId, int ackedState );
+    
+    void processZippedOutgoingPacket( byte * data, int length, int stateId );
+    void processZippedIncomingPacket( byte * data, int length, int stateId, int ackedState );
+    
+    void calculatePing();
+    
+    bool hasTimedOut();
+    
+    void printStatis();
+    
+  private:
+    float calculateBandWidth( std::map<int,int> packetHistory, int tick );
+    
+    int userId;       //!< user's id 
 
+    std::map<int,int>   sentStateTicks;
+    
+    std::map<int,int>   incomingUnzippedPacketHistory;
+    std::map<int,int>   outgoingUnzippedPacketHistory;
+    
+    std::map<int,int>   incomingZippedPacketHistory;
+    std::map<int,int>   outgoingZippedPacketHistory;
+    
+    std::list<int>      ackDelay;
+    int                 ping;
 
-  private:
-
-
-    void                displayStatistic();
-    void                computeCurrentDatarate();
-    void                doUDPRelatedStuff();
-
-    /*Data of the lifetime of the ConnectionMonitor Object*/
-    unsigned int        packetToAverage;
-    char*               protocollType;
-
-    unsigned int        totalReceivedPackets;
-    float               averageDatarate;
-    unsigned int        totalLostPackets;
-    float               totalPacketloss;
-    unsigned int        startTime;
-
-    /*Data of the current packet*/
-    unsigned int        currentPacketID;
-    unsigned int        currentPacketTick;
-    unsigned int        lastPacketID;
-    unsigned int        lastPacketTick;
-    unsigned int        currentDelay;
-
-    /*Data of the last n packets (n is specified by paxketsToAverage)*/
-    unsigned int        sizeOfLastFewPackets;
-    unsigned int        currentDatarate;
-    byte**              lastFewPackets;
-    unsigned int*       lastFewDelays;
-    unsigned int        packetCounter;
-
+    float               incomingUnzippedBandWidth;
+    float               outgoingUnzippedBandWidth;
+    
+    float               incomingZippedBandWidth;
+    float               outgoingZippedBandWidth;
+    
+    int                 nIncomingPackets;
+    int                 nOutgoingPackets;
+    
+    int                 nZIncomingPackets;
+    int                 nZOutgoingPackets;
+    
+    int                 lastPacketTick;
+    
+    int                 lastPrintTick;
   };
 
Index: /trunk/src/lib/network/converter.cc
===================================================================
--- /trunk/src/lib/network/converter.cc	(revision 7953)
+++ /trunk/src/lib/network/converter.cc	(revision 7954)
@@ -489,9 +489,20 @@
   {
     PRINTF(1)("something went wrong length > remaining bytes in buffer\n" );
+    
+    //TODO remove this
+    for ( int i = -1000; i < 1001; i++ )
+    {
+      if ( ( a[i] > 'a' && a[i] < 'z' ) || ( a[i] > 'A' && a[i] < 'Z' ) )
+        printf("%c", a[i]);
+      else
+        printf(".");
+    }
+    printf("\n");
+    
     s = "";
     return -1;
   }
 
-  s[0] = '\0';
+  s = "";
   s.append( (char*)a+n, length );
 
